from uuid import UUID

from pydantic import BaseModel, ConfigDict


class ProductBaseSchema(BaseModel):
    name: str | None = None


class ProductIdSchema(BaseModel):
    id: UUID
    model_config = ConfigDict(from_attributes=True)


class ProductListSchema(ProductBaseSchema, ProductIdSchema):
    pass


class ProductGetSchema(ProductBaseSchema, ProductIdSchema):
    description: str | None = None
    price: float | None = None
    image: str | None = None
